-- | This module defines some pretty-printing combinators that are not
-- provided in the core Text.PrettyPrint module.
module Util.PrettyPrintHelpers
  (
    bool
  , vsep
  , commaSep
  , parensWhen
  ) where

import Text.PrettyPrint

bool :: Bool -> Doc
bool b = text (if b then "true" else "false")

vsep :: [Doc] -> Doc
vsep = sep . punctuate (text "\n")

commaSep :: [Doc] -> Doc
commaSep = sep . punctuate comma

parensWhen :: Bool -> Doc -> Doc
parensWhen b d = if b then parens d else d
