{-# LANGUAGE GeneralizedNewtypeDeriving, StandaloneDeriving #-}
{-# OPTIONS -Wall #-}
module Util.Unique
  ( Unique
  , runUnique
  , unique
  ) where

import Control.Monad.State (State, evalState, get, put, MonadState)

newtype Unique u a = Unique (State [u] a)

deriving instance Monad (Unique u)

runUnique :: Unique u a -> [u] -> a
runUnique (Unique s) = evalState s

unique :: Unique u u
unique = Unique $ do
  (u : us) <- get
  put us
  return u
