#ifndef TEST_ARRAY_HPP
#define TEST_ARRAY_HPP

#include "random.hpp"
#include <boost/shared_array.hpp>

template <class T>
boost::shared_array<T>
new_test_array(rand_gen<T> &generator, const unsigned length)
{
    boost::shared_array<T> arr(new T[length]);
    for (unsigned i = 0; i < length; i += 1)
        arr[i] = generator();
    return arr;
}

template <class T>
boost::shared_array<T>
new_test_array(rand_gen<T> &generator, const unsigned length, const T low, const T high)
{
    typedef boost::variate_generator<
        rand_src,
        typename rng_traits<T>::distribution_t
        > gen_t;
    gen_t gen (
        generator.get_rand_src(),
        typename rng_traits<T>::distribution_t(low, high)
        );

    boost::shared_array<T> arr(new T[length]);
    for (unsigned i = 0; i < length; i += 1)
        arr[i] = gen();
    return arr;
}


typedef boost::shared_array<float> float_test_array;
typedef boost::shared_array<int> int_test_array;
typedef boost::shared_array<unsigned> unsigned_test_array;


#endif
