#ifndef SLICE_HPP
#define SLICE_HPP

#include "host_and_device.hpp"
#include "utility_functions.hpp"

struct slice
{
    inline
    slice (
        const int start,
        const int stop,
        const int stride
        ) : _start  (start)
          , _stop   (stop)
          , _stride (stride)
        {
        }

    HOST_AND_DEVICE
    inline
    int operator () (const int idx) const
    {
        return _start + idx * _stride;
    }

    HOST_AND_DEVICE
    inline
    int length () const
    {
        return int_abs (int_abs (_stop - _start) / _stride);
    }

    HOST_AND_DEVICE
    inline
    int start () const
    {
        return _start;
    }

    HOST_AND_DEVICE
    inline
    int stop () const
    {
        return _stop;
    }

    HOST_AND_DEVICE
    inline
    int stride () const
    {
        return _stride;
    }

    const int _start;
    const int _stop;
    const int _stride;
};

#endif // SLICE_HPP
