#include "gpu_add1_2d.hpp"
#include "cpu_add1_2d.hpp"
#include "barracuda_test.hpp"


bool test_add1_2d (float_gen &generator,
                   const unsigned rows,
                   const unsigned cols)
{
  const float_test_array initVals1 = new_test_array(generator, rows * cols);

  const gpu_float_matrix gpu_input(rows, cols, initVals1.get());
  gpu_float_matrix gpu_result(rows, cols);

  const float_matrix cpu_input(rows, cols, initVals1.get());
  float_matrix cpu_result(rows, cols);

  gpu_add1_2d(gpu_input, gpu_result);
  cpu_add1_2d(cpu_input, cpu_result);

  return compare_matrices(float_matrix(gpu_result), cpu_result);
}
