#include "gpu_add1.hpp"
#include "cpu_add1.hpp"
#include "barracuda_test.hpp"


bool test_add1 (float_gen &generator, const unsigned len)
{
  const float_test_array initVals1 = new_test_array(generator, len);

  const gpu_float_array gpu_input(len, initVals1.get());
  gpu_float_array gpu_result(len);

  const float_array cpu_input(len, initVals1.get());
  float_array cpu_result(len);

  gpu_add1(gpu_input, gpu_result);
  cpu_add1(cpu_input, cpu_result);

  return compare_arrays(float_array(gpu_result), cpu_result);
}
