module Main (main) where

import Language.Barracuda

add :: MExpr Float -> MExpr Float -> MExpr Float -> MExpr Float
add x y z = mzipWith (+) x (mzipWith (+) y z)

cpuAdd :: [Function]
cpuAdd = [Function add "cpu_add_matrices3" ["x", "y", "z"] "result"]

gpuAdd :: [Function]
gpuAdd = [Function add "gpu_add_matrices3" ["x", "y", "z"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_add_matrices3.hpp", "cpu_add_matrices3.cpp") cpuAdd
  compile defaultCudaConfig ("gpu_add_matrices3.hpp", "gpu_add_matrices3.cu")  gpuAdd
