module Main (main) where

import Language.Barracuda

-- | Add the sum of the first array to each element of the second.
-- Demonstrates nested use of the array operations.
addSum :: AExpr Float -> AExpr Float -> AExpr Float
addSum arr1 arr2 = amap (asum arr1 +) arr2

test :: String -> [Function]
test p = [Function addSum (p ++ "_add_sum") ["x", "y"] "result"]

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_add_sum.hpp", "cpu_add_sum.cpp") (test "cpu")
  compile defaultCudaConfig ("gpu_add_sum.hpp", "gpu_add_sum.cu")  (test "gpu")
