#include "gpu_noshmem_col_shift_multiply.hpp"
#include "gpu_shmem_col_shift_multiply.hpp"
#include "cpu_col_shift_multiply.hpp"
#include "barracuda_test.hpp"


bool test_col_shift_multiply (float_gen &generator,
                              const unsigned rows,
                              const unsigned cols)
{
  const float_test_array initVals1 = new_test_array(generator, rows * cols);

  const gpu_float_matrix gpu_noshmem_input(rows, cols, initVals1.get());
  gpu_float_matrix gpu_noshmem_result(rows, cols - 1);

  const gpu_float_matrix gpu_shmem_input(rows, cols, initVals1.get());
  gpu_float_matrix gpu_shmem_result(rows, cols - 1);

  const float_matrix cpu_input(rows, cols, initVals1.get());
  float_matrix cpu_result(rows, cols - 1);

  gpu_noshmem_col_shift_multiply(gpu_noshmem_input, gpu_noshmem_result);
  gpu_shmem_col_shift_multiply(gpu_shmem_input, gpu_shmem_result);
  cpu_col_shift_multiply(cpu_input, cpu_result);

  return
      compare_matrices(float_matrix(gpu_noshmem_result), cpu_result) &&
      compare_matrices(float_matrix(gpu_shmem_result), cpu_result);
}
