module Main (main) where

import Language.Barracuda

colShiftMultiply :: MExpr Float -> MExpr Float
colShiftMultiply m = mzipWith (*) m' m''
  where m'  = mslice m (0, mrows m, 1) (1, mcols m, 1)
        m'' = mslice m (0, mrows m, 1) (0, mcols m - 1, 1)

fun :: String -> [Function]
fun p = [Function colShiftMultiply (p ++ "_col_shift_multiply") ["x"] "result"]

main :: IO ()
main = do
  compile
    defaultCppConfig
    ("cpu_col_shift_multiply.hpp", "cpu_col_shift_multiply.cpp")
    (fun "cpu")
  compile
    defaultCudaConfig
    ("gpu_noshmem_col_shift_multiply.hpp", "gpu_noshmem_col_shift_multiply.cu")
    (fun "gpu_noshmem")
  compile
    (CudaTarget CudaConfig { sharedMemoryOptimization = True })
    ("gpu_shmem_col_shift_multiply.hpp", "gpu_shmem_col_shift_multiply.cu")
    (fun "gpu_shmem")
