#include "gpu_jacobi_diff.hpp"
#include "cpu_jacobi_diff.hpp"
#include "barracuda_test.hpp"


bool test_jacobi_diff (float_gen &generator,
                       const unsigned rows,
                       const unsigned cols)
{
  if (rows < 2 || cols < 2) return true;

  const float_test_array initVals1 = new_test_array(generator, rows * cols);
  const float_test_array initVals2 = new_test_array(generator, rows * cols);

  const gpu_float_matrix gpu_input1(rows, cols, initVals1.get());
  const gpu_float_matrix gpu_input2(rows, cols, initVals2.get());
  float gpu_result;

  const float_matrix cpu_input1(rows, cols, initVals1.get());
  const float_matrix cpu_input2(rows, cols, initVals2.get());
  float cpu_result;

  gpu_jacobi_diff(gpu_input1, gpu_input2, gpu_result);
  cpu_jacobi_diff(cpu_input1, cpu_input2, cpu_result);

  return compare(cpu_result, gpu_result);
}
