module Main (main) where

import Language.Barracuda

mmax :: MExpr Float -> SExpr Float
mmax = mreduce max (-1e12)
  where max x y = scond (x >* y) x y

mmaxTest :: String -> [Function]
mmaxTest p = [Function mmax name ["array1"] "result"]
  where name = p ++ "_matrix_max"

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_matrix_max.hpp", "cpu_matrix_max.cpp") (mmaxTest "cpu")
  compile defaultCudaConfig ("gpu_matrix_max.hpp", "gpu_matrix_max.cu")  (mmaxTest "gpu")
