module Main (main) where

import Language.Barracuda

msum :: MExpr Float -> SExpr Float
msum = mreduce (+) 0

msumTest :: String -> [Function]
msumTest p = [Function msum name ["array1"] "result"]
  where name = p ++ "_matrix_sum"

main :: IO ()
main = do
  compile defaultCppConfig ("cpu_matrix_sum.hpp", "cpu_matrix_sum.cpp") (msumTest "cpu")
  compile defaultCudaConfig ("gpu_matrix_sum.hpp", "gpu_matrix_sum.cu")  (msumTest "gpu")
