#include "gpu_rmse.hpp"
#include "cpu_rmse.hpp"
#include "barracuda_test.hpp"

bool test_rmse (float_gen &generator, const unsigned len)
{
  float_test_array initVals1 = new_test_array(generator, len);
  float_test_array initVals2 = new_test_array(generator, len);

  const gpu_float_array gpu_arr1(len, initVals1.get());
  const gpu_float_array gpu_arr2(len, initVals2.get());
  float gpu_result;

  const float_array cpu_arr1(len, initVals1.get());
  const float_array cpu_arr2(len, initVals2.get());
  float cpu_result;

  gpu_rmse(gpu_arr1, gpu_arr2, gpu_result);
  cpu_rmse(cpu_arr1, cpu_arr2, cpu_result);

  return compare(gpu_result, cpu_result);
}
