module Main (main) where

import Language.Barracuda

rowShiftMultiply :: MExpr Float -> MExpr Float
rowShiftMultiply m = mzipWith (*) m' m''
  where m'  = mslice m (1, mrows m, 1) (0, mcols m, 1)
        m'' = mslice m (0, mrows m - 1, 1) (0, mcols m, 1)

fun :: String -> [Function]
fun p = [Function rowShiftMultiply (p ++ "_row_shift_multiply") ["x"] "result"]

main :: IO ()
main = do
  compile
    defaultCppConfig
    ("cpu_row_shift_multiply.hpp", "cpu_row_shift_multiply.cpp")
    (fun "cpu")
  compile
    defaultCudaConfig
    ("gpu_noshmem_row_shift_multiply.hpp", "gpu_noshmem_row_shift_multiply.cu")
    (fun "gpu_noshmem")
  compile
    (CudaTarget CudaConfig { sharedMemoryOptimization = True })
    ("gpu_shmem_row_shift_multiply.hpp", "gpu_shmem_row_shift_multiply.cu")
    (fun "gpu_shmem")
